' FRACT.bas  ....     versuche zum MandelBumchen     McCopies&D.Stribute 2001
' save as array of integers -> d:\FRACT.BIN
' save "inside" values, too     a) log scale    b) zsteps (list)
' calc/save/read zs using zv (all Z Values)
' nst steps   V1.8 symetry k1111=1111
' V2.0  use FORTRAN module (FRACTF.EXE) for calculation
' V2.1  using FRACTF.EXE V1.06, NV=16
' V2.2  using FRACTF.EXE V1.07, NV=32


' bytes   1-31 "W:A 1.xx --date-- --time-- "
'         32   chr$(26)         -eof-
'         33-36 width/height    2 bytes each
'         37-40 kmin/kmax     999 if not finished
'         41-44 k2min/k2max
'         45-46 nst  # of steps for inside
'         47-48 0 | 1111 = imgage symetrical, only 1/2 lines in file
'         129--  w*h values

' bailoutvalue=rmax   max.rechentiefe=n

DEFINT I-N

DECLARE FUNCTION rgb& (r%, g%, b%)
DECLARE SUB inipal ()             ' ??? OLD
DECLARE SUB cyclepal ()           ' ??? OLD
DECLARE SUB readcol ()            ' ??? OLD
DECLARE SUB copypal ()            ' ??? OLD
DECLARE SUB waitkb ()
DECLARE SUB iniStep ()   ' initialize zstep
DECLARE SUB readSteps ()
DECLARE SUB writeSteps ()
DECLARE SUB calcSteps ()
DECLARE SUB tauschZV (i%, j%)

DIM xx AS INTEGER: DIM yy AS INTEGER
DIM min AS INTEGER: DIM max AS INTEGER: DIM k AS INTEGER
DIM SHARED kwait AS LONG
DIM SHARED pal&(0 TO 32)
DIM minr AS SINGLE, maxr AS SINGLE

DIM SHARED NST AS INTEGER
NST = 64
DIM SHARED zstep(1 TO NST) AS SINGLE   ' zsteps for calculating k2 values
DIM SHARED zs(1 TO NST) AS SINGLE      ' optimized calculated zsteps

nzv = 10000
DIM SHARED zv(1 TO nzv) AS SINGLE
DIM SHARED nk2 AS INTEGER
DIM SHARED dir$
DIM SHARED d0$

ON KEY(11) GOSUB up: ON KEY(14) GOSUB down

KEY(0) ON  ' ------------------------------------------------
SCREEN 12
PRINT "FRACT.BAS - V2.2"

          ' ** <<<<<< set FORTRAN-switch  and  DIRECTORIES

FORTRAN = 0     ' do NOT use fortran module
FORTRAN = 1     ' use fortran module FRACTF.EXE


d0$ = "c:\": dir$ = "c:\spiele\frac3d\"   ' SB's toshiba notebook
'd0$ = "d:\": dir$ = "d:\f3d\"

iniStep
calc = 1     ' ** calc optimized zsteps and save to fract.dat
'calc = 0     ' dont optimize zsteps  // use "-1" for ALL inside points
calc = -1    ' read Steps from file fract.dat
calc = -2    ' read Steps from file fract.dat + 1

IF FORTRAN > 0 THEN calc = -1  ' read=check FRACT.DAT before running FRACTF.EXE

kprint = 0 ' choose: 0/1/2

'xmin = -1.7: xmax = .7: ymin = -1.2: ymax = 1.2  ' M1
'xmin = -3.7: xmax = 2.7: ymin = -3.2: ymax = 3.2  ' M2
'xmin = -8: xmax = 8: ymin = -8: ymax = 8  ' M3

'xmin = .74: xmax = .76: ymin = -.035: ymax = -.015 ' size=0.02
'xmin = .7: xmax = .8: ymin = -.1: ymax = 0 ' Wirbel-7...OK  size=0.1
'xmin = .6: xmax = .9: ymin = -.2: ymax = .1  ' Wirbel-8...OK

'xmin = -1.5: xmax = 1.5: ymin = -1.5: ymax = 1.5 ' M1
'rmax = 100: n = 200      : sx=1

'xmin = .750919: xmax = .751036: ymin = -.02526: ymax = -.02514   ' WirbelX1
'deltaX= 0.000117  deltaY= 0.000120
'rmax = 100: n = 800 :sx=-1  ' minRT(Wirbel)= X00 !!        WIRBEL => LINKS !!!

'xmin = .75092: xmax = .75104: ymin = -.02526: ymax = -.02514     ' WirbelX2
'deltaX=deltaY=0.000120

'rmax = 100: n = 100 : sx=1           ' apfelmnnchen=RECHTS, sx=1
'xmin = -1.7: xmax = .7: ymin = -1.2: ymax = 1.2  ' M1  2.4 x 2.4
'xmin = -2.7: xmax = .9: ymin = -1.2: ymax = 1.2  ' M1  3.6 x 2.4

'xmin = .7509: xmax = .75106: ymin = -.02526: ymax = -.02514      ' WirbelX6
'rmax = 100: n = 550: sx = -1 ' minRT(Wirbel)= X00 !!   WIRBEL=LINKS,sx=-1
'deltaX=0.000160  deltaY=0.000120     4x3

'xmin = .7509: xmax = .75106: ymin = -.02526: ymax = -.02514      ' WirbelX7
'rmax = 100: n = 700: sx = -1 ' minRT(Wirbel)= X00 !!   WIRBEL=LINKS,sx=-1
'deltaX=0.000160  deltaY=0.000120     4x3

'xmin = -3: xmax = 1: ymin = -1.5: ymax = 1.5  ' M4  4.0 x 3.0
'@@xmin = -2.7: xmax = .9: ymin = -1.2: ymax = 1.2  ' M6  3.6 x 2.4  <>4:3 !@!

rmax = 100
'sx = 1    '  apfelmnnchen=(spitze_nach)RECHTS, sx=1


' M10: MANDELBROT set, "island" at -0.15/1.04  magnified  20*
'xmin = -.23: xmax = -.07: ymin = .98: ymax = 1.1     ' M10  0.16 x 0.12
'n = 25000

'k1111 = 1111    ' symetrical image !
'xmin = -2.5: xmax = .7: ymin = -1.2: ymax = 1.2  ' M7  3.2 x 2.4  = 4:3
'n = 20


'XMIN = .7509076: XMAX = .7509124: YMIN = -.0252509: ymax = -.0252473  '..
'xmax = 2 * xmax - xmin: ymax = 2 * ymax - ymin   ' 2*  up+right = WiZoo1
'XMIN = 2 * XMIN - XMAX: ymax = 2 * ymax - YMIN    ' 2*  up+left = WiZoo2


'xmin = .7509192#: xmax = .750928
'ymin = -.0252537: ymax = -.0252471#   ' 8.8x6.6(-6)  WiZoo3 !

rmax = 100: N = 700: sx = -1' minRT(Wirbel)= X00 !!   WIRBEL=LINKS,sx=-1
xmin = .7509: xmax = .75106: ymin = -.02526: ymax = -.02514      ' WirbelX7

PRINT xmax, xmin, xmax - xmin
PRINT ymax, ymin, ymax - ymin


                     ' *** <<<<<<<<<<<<<<<< set picture parameters
                     ' zz = verkleinerungsfaktor      sx := signum(x)

zz = 20             ' mini preview 32 x 24
zz = 10             ' preview 64 x 48
zz = 8              ' preview 80 x 60
zz = 4              ' small 160 x 120
zz = 2              ' medium 320 x 240
'zz = 1              ' regular 640 x 480 !
'zz = 1 / 2          ' 2*  1280 x 960    !!
'zz = 1 / 3          ' 3*  1920 x 1440   !!!
'zz = 1 / 4          ' 4*  2560 x 1920   !!!!
zz = 1 / 5          ' 5*  3200 x 2400   !!!!!


xx = 640 / zz: yy = 480 / zz          ' 3:4    1=fullSize

' xx = 480 / zz: yy = 480 / zz          ' quadratisch

krand = 0
IF zz > 1 THEN krand = 100 ' rand    := 0 fr groessere bilder!


maxr = 0: minr = rmax
k2min = 0: k2max = -30000: nk2 = 0
min = N    ' minimale rechentiefe

IF kprint > 0 THEN
LOCATE 24, 1: PRINT "x:"; xmin; xmax; "   y:"; ymin; ymax; "   ";
PRINT "size "; xmax - xmin; " x "; ymax - ymin
END IF


' ----- open binary outputfile: ----
f$ = d0$ + "fract.bin"
OPEN f$ FOR BINARY AS #1
c$ = "W:A 1.08 " + DATE$ + " " + TIME$ + "            "

MID$(c$, 30, 1) = CHR$(10)   ' CR
MID$(c$, 31, 1) = CHR$(13)   ' LF
MID$(c$, 32, 1) = CHR$(26)   ' ctrl-z   =  eof
DIM c32 AS STRING * 32
c32 = LEFT$(c$, 32)
PUT #1, 1, c32
c$ = "                                       "
c32 = LEFT$(c$, 32)
PUT #1, 33, c32
PUT #1, 65, c32
PUT #1, 97, c32
k999 = 999
PUT #1, 33, xx    ' width
PUT #1, 35, yy    ' height
PUT #1, 37, k999  ' 999 = file not finished
PUT #1, 39, k999  ' 999 = file not finished
xc& = 129          ' write counter              128 bytes HEADER !

IF calc < 0 AND FORTRAN = 0 THEN readSteps
IF calc = -2 THEN calc = 1

rrmin = 1E-20
max = 0: min = N
dx = (xmax - xmin) / (xx - 1)
dy = (ymax - ymin) / (yy - 1)

yy2 = yy
IF k1111 = 1111 THEN yy2 = yy / 2   ' symetrical image: store only 1/2


IF FORTRAN = 0 THEN             ' ========================================

' ---------- cycle over all points: -----------

LOCATE 30, 1: PRINT "working ...";

FOR iy = 0 TO (yy2 - 1)
y00 = ymin + iy * dy

FOR ix = 0 TO (xx - 1)

IF kprint > 0 THEN
LOCATE 22, 1: PRINT ix, iy, k, min,
END IF

'x = xmin + ix / xx * (xmax - xmin)
x = xmin + ix * dx
x = x * sx        ' sx=signum(x) set above to 1/-1
y = y00
r = x * x + y * y
x0 = x: y0 = y             ' Mandelbrot
' x0 = -.25: y0 = -.25              ' Julia

' --- cycle over RECHENTIEFE: ---

FOR k = 1 TO N
x2 = x * x: y2 = y * y               ' faster
y = 2 * x * y + y0: x = x2 - y2 + x0 ' complex zn = z^2 + z0
r = x2 + y2

IF r > rmax THEN

IF k < min THEN min = k
IF k > max THEN max = k
col = k MOD 16                   ' k=1..n  col=0..15   k=min..max
GOTO lbl1

END IF   ' r>rmax == OUTSIDE
  
NEXT k

IF calc <> 0 THEN   ' -----------------------

         ' max.RT == INSIDE

IF r > maxr THEN maxr = r    ' new maximum r
IF r < minr THEN minr = r    ' new minimum r

' --- convert r to k2: ---  k2 = -1 .. -nst
FOR k2 = 1 TO NST - 1
IF r > zstep(k2) GOTO lblk
NEXT k2
k2 = NST
lblk:
k2 = -k2
IF k2 > k2max THEN k2max = k2      ' k2 boundaries
IF k2 < k2min THEN k2min = k2

IF calc > 0 THEN
  nk2 = nk2 + 1             ' store all values in zv
  IF nk2 < nzv THEN
    zv(nk2) = r
  ELSE
    calc = 0
    BEEP: BEEP: PRINT " ZV overflow. switching to calc=0"
  END IF
END IF

ELSE    ' calc=0  -----
k2 = -1
END IF  ' calc<>0 -----

col = -k2 MOD 16
k = k2               ' k<0 !


lbl1:

IF zz < 1 THEN
kx = ix * zz: ky = iy * zz
ELSE
kx = ix: ky = iy
END IF
PSET (krand + kx, 481 - (krand + ky)), col        ' SCREEN output

' scale by zz
'PSET (krand + ix, 480 - (krand + iy)), col        ' SCREEN output
' flip
'PSET (krand + ix, krand + iy), col          ' SCREEN output
' aufgestellt:
'PSET (krand + iy, krand + ix), col


PUT #1, xc&, k            ' <<<<<<<<<<<<<<< BMP FILE output
xc& = xc& + 2

            
NEXT ix

'lOCATE 28, 10: PRINT "line "; iy;

NEXT iy     '  ----- end of cycles -----


ELSE                            ' ========= FORTRAN=1=YES ================
PRINT
PRINT "using FORTRAN module for calculation:"
PRINT "writing parameter file FRACTF.INP ...";
OPEN "FRACTF.INP" FOR OUTPUT AS #8
PRINT #8, xx
PRINT #8, yy
PRINT #8, N
PRINT #8, USING "#######.#######"; rmax
PRINT #8, xmin * sx
PRINT #8, xmax * sx                    ' write parameters to FRACTF.INP
PRINT #8, ymin
PRINT #8, ymax
PRINT #8, NST
PRINT #8, "------------"
CLOSE #8

PRINT " done."
PRINT "spawning FORTRAN module FRACTF.EXE for calculation ....";
SHELL "FRACTF.EXE" ' run FRACTF.EXE to generate FRACTF.BIN <<<<<<<<<<<<<<<<<<

PRINT " ... back to FRACT.BAS"
PRINT "converting FRACTF.BIN into FRACT.BIN ...";

OPEN "FRACTF.BIN" FOR BINARY AS #8
rdptr& = 5

NV = 32    ' Number of integer*2 Values per record
DIM c64 AS STRING * 64

j& = xx
j& = j& * yy / NV    ' number of blocks of NV*I2 to copy

FOR i& = 1 TO j&

GET #8, rdptr&, c64         ' <<<<<<<<<<<<<<< FORTRAN bin-FILE input
rdptr& = rdptr& + NV * 2 + 8  ' skip 2*4 bytes per record

PUT #1, xc&, c64            ' <<<<<<<<<<<<<<< BMP FILE output
xc& = xc& + NV * 2

NEXT i&

CLOSE #8


END IF  ' FORTRAN or NO ==================================================


' -- write min/max to outfile: --

PUT #1, 37, min     ' k min value
PUT #1, 39, max     ' k max value
PUT #1, 41, k2min   ' k2 min value
PUT #1, 43, k2max   ' k2 max value
PUT #1, 45, NST     ' nst .. number of steps for inside
PUT #1, 47, k1111   ' flag for mirror-symetrical image
CLOSE 1

LOCATE 28, 1: PRINT "maxr,minr="; maxr; minr
PRINT "k2min,k2max="; k2min; k2max; "  nk2="; nk2

LOCATE 30, 1: PRINT xc& - 1; " bytes saved to file "; f$; "   ";


IF calc > 0 THEN

IF nk2 = 0 THEN
BEEP: BEEP: BEEP
PRINT
PRINT "ERROR:  NO 'INSIDE' POINTS FOUND !!!"
PRINT
ELSE   ' nk2>0

calcSteps
writeSteps
END IF    ' nk2
END IF   ' calc

SYSTEM

'  -- color plays : --

waitkb

inipal

waitkb

readcol

cyclepal


SYSTEM
END

up:

kwait = kwait * 2
IF kwait < 1 THEN kwait = 1
LOCATE 26, 1: PRINT kwait,
RETURN

down:

kwait = kwait / 2
IF kwait < 2 THEN BEEP
LOCATE 26, 1: PRINT kwait,
RETURN

SUB calcSteps

LOCATE 29, 1
PRINT "calculating new zSteps. please wait!    ...";

'  order  ascendingly  zv(1 to nk2)

FOR i = 1 TO nk2 - 1
FOR j = i + 1 TO nk2
IF zv(j) < zv(i) THEN tauschZV i, j

'LOCATE 26, 1: PRINT i, j,

NEXT j
LOCATE 26, 1: PRINT i
NEXT i


END SUB

DEFSNG I-N
SUB copypal

FOR i = 0 TO 15
pal&(16 + i) = pal&(i)
NEXT i

END SUB

SUB cyclepal   ' cycle color palette pal&

kwait = 10
k = 1

lbl0:
FOR i = 1 TO 15
PALETTE i, pal&(i + k)

FOR kkk = 1 TO kwait
NEXT kkk

NEXT i
k = k + 1
IF k > 15 THEN k = 1

IF INKEY$ = CHR$(27) THEN SYSTEM


GOTO lbl0


END SUB

SUB inipal      ' ini PAL&(0:15) with DOS color palette

pal&(0) = rgb&(0, 0, 0)
pal&(1) = rgb&(0, 0, 50)
'pal&(2) = rgb&(0, 50, 0)
pal&(2) = rgb&(0, 70, 0)
pal&(3) = rgb&(0, 50, 50)
pal&(4) = rgb&(50, 0, 0)
pal&(5) = rgb&(50, 0, 50)
pal&(6) = rgb&(50, 50, 0)
pal&(7) = rgb&(75, 75, 75)
pal&(8) = rgb&(50, 50, 50)
pal&(9) = rgb&(0, 0, 100)
pal&(10) = rgb&(0, 100, 0)
pal&(11) = rgb&(0, 100, 100)
pal&(12) = rgb&(100, 0, 0)
pal&(13) = rgb&(100, 0, 100)
pal&(14) = rgb&(100, 100, 0)
pal&(15) = rgb&(100, 100, 100)

FOR i = 0 TO 15
pal&(16 + i) = pal&(i)
NEXT i

PALETTE USING pal&

END SUB

DEFINT I-N
SUB iniStep             ' initialize zstep

zstep(1) = 1
zstep(2) = .9
zstep(3) = .8
zstep(4) = .7
zstep(5) = .6
zstep(6) = .5
zstep(7) = .4
zstep(8) = .3
zstep(9) = .2
zstep(10) = .1
zstep(11) = .09
zstep(12) = .08
zstep(13) = .06
zstep(14) = .04
zstep(15) = .01
zstep(16) = .001

FOR i = 17 TO NST
zstep(i) = .0001
NEXT i

END SUB

SUB oldCode

'---------------------------------------------------------------
IF r < rrmin THEN       '--- logarithmic steps ---
k2 = 0
ELSE
k2 = INT(LOG(r / rmax)) - 1         ' -1/-2/...-1000/...?
IF k2 > 0 THEN SYSTEM   ' irrtum
END IF

'---------------------------------------------------------------


'---------------------------------------------------------------
'---------------------------------------------------------------


END SUB

DEFSNG I-N
SUB readcol   ' read color palette from F3D's *.col file

f$ = "grschw.col"
f$ = "rotschw.col"
f$ = "bw.col"
f$ = "blschw.col"
f$ = "blw.col"
f$ = "blaurot.col"
f$ = "turkis.col"
f$ = "braun.col"
f$ = "dos.col"
f$ = "r_b.col"
f$ = "r_g&.col"
f$ = "rgb&.col"
f$ = "rgb.col"
f$ = "a.col"
f$ = "apfel.col"

f$ = dir$ + f$
OPEN f$ FOR BINARY AS #1
DIM c AS STRING * 48
GET #1, 184, c
CLOSE 1

FOR i = 0 TO 15
k = i * 3 + 1
c1$ = MID$(c, k)
c2$ = MID$(c, k + 1)
c3$ = MID$(c, k + 2)
'x& = ASC(c1$)
'x& = x& * 256 + ASC(c3$)
'x& = x& * 256 + ASC(c2$)

x& = ASC(c3$)
x& = x& * 256 + ASC(c2$)
x& = x& * 256 + ASC(c1$)

pal&(i) = x&

NEXT i

copypal

PALETTE USING pal&

LOCATE 27, 30: PRINT "palette loaded from "; f$,


END SUB

DEFINT I-N
SUB readSteps
f$ = d0$ + "fract.dat"
OPEN f$ FOR INPUT AS #9
LOCATE 1, 1
FOR i = 1 TO NST
INPUT #9, zstep(i)
'PRINT i, ;
'PRINT USING "##.###### "; zstep(i)
NEXT i
CLOSE #9
PRINT "readSteps - done."
'waitkb
END SUB

DEFSNG I-N
FUNCTION rgb& (r%, g%, b%)

'  input: red-green-blue values in % as integer
' output: long rgb&

r = INT(.01 * r% * 64)
g = INT(.01 * g% * 64)
b = INT(.01 * b% * 64)

IF r > 63 THEN r = 63
IF g > 63 THEN g = 63
IF b > 63 THEN b = 63

rgb& = r + 256 * (g + 256 * b)

END FUNCTION

DEFINT I-N
SUB tauschZV (i, j)
zvv = zv(j)
zv(j) = zv(i)
zv(i) = zvv
END SUB

DEFSNG I-N
SUB waitkb
BEEP: WHILE INKEY$ = "": WEND ' wait for keyboard input
END SUB

SUB writeSteps
f$ = d0$ + "fract.dat"
OPEN f$ FOR OUTPUT AS #9

i1 = NST - 1
FOR i = i1 TO 1 STEP -1

k = INT(i * nk2 / NST)
'PRINT i, k

PRINT #9, zv(k)

NEXT i

zz = 0!
PRINT #9, zz
CLOSE #9

PRINT " writeSteps - done."

END SUB

